# coding: utf-8

"""
    DocuSign Admin API

    An API for an organization administrator to manage organizations, accounts and users  # noqa: E501

    OpenAPI spec version: v2.1
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..client.configuration import Configuration
from ..client.api_client import ApiClient


class DSGroupsApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def add_ds_group(self, organization_id, account_id, add_request, **kwargs):
        """
        Add a new DSGroup
        Required scopes: user_write
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.add_ds_group(organization_id, account_id, add_request, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :param DSGroupAddRequest add_request: Add DSGroup request object (required)
        :return: DSGroupResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.add_ds_group_with_http_info(organization_id, account_id, add_request, **kwargs)
        else:
            (data) = self.add_ds_group_with_http_info(organization_id, account_id, add_request, **kwargs)
            return data

    def add_ds_group_with_http_info(self, organization_id, account_id, add_request, **kwargs):
        """
        Add a new DSGroup
        Required scopes: user_write
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.add_ds_group_with_http_info(organization_id, account_id, add_request, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :param DSGroupAddRequest add_request: Add DSGroup request object (required)
        :return: DSGroupResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['organization_id', 'account_id', 'add_request']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_ds_group" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'organization_id' is set
        if ('organization_id' not in params) or (params['organization_id'] is None):
            raise ValueError("Missing the required parameter `organization_id` when calling `add_ds_group`")
        # verify the required parameter 'account_id' is set
        if ('account_id' not in params) or (params['account_id'] is None):
            raise ValueError("Missing the required parameter `account_id` when calling `add_ds_group`")
        # verify the required parameter 'add_request' is set
        if ('add_request' not in params) or (params['add_request'] is None):
            raise ValueError("Missing the required parameter `add_request` when calling `add_ds_group`")


        collection_formats = {}

        resource_path = '/v2.1/organizations/{organizationId}/accounts/{accountId}/dsgroups'.replace('{format}', 'json')
        path_params = {}
        if 'organization_id' in params:
            path_params['organizationId'] = params['organization_id']
        if 'account_id' in params:
            path_params['accountId'] = params['account_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'add_request' in params:
            body_params = params['add_request']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='DSGroupResponse',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def add_ds_group_users(self, organization_id, account_id, ds_group_id, d_s_group_users_add_request, **kwargs):
        """
        Add list of users to a DSGroup
        Required scopes: user_write
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.add_ds_group_users(organization_id, account_id, ds_group_id, d_s_group_users_add_request, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :param str ds_group_id: The DSGroup ID GUID (required)
        :param DSGroupUsersAddRequest d_s_group_users_add_request: Add DSGroup users request object (required)
        :return: AddDSGroupAndUsersResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.add_ds_group_users_with_http_info(organization_id, account_id, ds_group_id, d_s_group_users_add_request, **kwargs)
        else:
            (data) = self.add_ds_group_users_with_http_info(organization_id, account_id, ds_group_id, d_s_group_users_add_request, **kwargs)
            return data

    def add_ds_group_users_with_http_info(self, organization_id, account_id, ds_group_id, d_s_group_users_add_request, **kwargs):
        """
        Add list of users to a DSGroup
        Required scopes: user_write
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.add_ds_group_users_with_http_info(organization_id, account_id, ds_group_id, d_s_group_users_add_request, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :param str ds_group_id: The DSGroup ID GUID (required)
        :param DSGroupUsersAddRequest d_s_group_users_add_request: Add DSGroup users request object (required)
        :return: AddDSGroupAndUsersResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['organization_id', 'account_id', 'ds_group_id', 'd_s_group_users_add_request']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_ds_group_users" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'organization_id' is set
        if ('organization_id' not in params) or (params['organization_id'] is None):
            raise ValueError("Missing the required parameter `organization_id` when calling `add_ds_group_users`")
        # verify the required parameter 'account_id' is set
        if ('account_id' not in params) or (params['account_id'] is None):
            raise ValueError("Missing the required parameter `account_id` when calling `add_ds_group_users`")
        # verify the required parameter 'ds_group_id' is set
        if ('ds_group_id' not in params) or (params['ds_group_id'] is None):
            raise ValueError("Missing the required parameter `ds_group_id` when calling `add_ds_group_users`")
        # verify the required parameter 'd_s_group_users_add_request' is set
        if ('d_s_group_users_add_request' not in params) or (params['d_s_group_users_add_request'] is None):
            raise ValueError("Missing the required parameter `d_s_group_users_add_request` when calling `add_ds_group_users`")


        collection_formats = {}

        resource_path = '/v2.1/organizations/{organizationId}/accounts/{accountId}/dsgroups/{dsGroupId}/users'.replace('{format}', 'json')
        path_params = {}
        if 'organization_id' in params:
            path_params['organizationId'] = params['organization_id']
        if 'account_id' in params:
            path_params['accountId'] = params['account_id']
        if 'ds_group_id' in params:
            path_params['dsGroupId'] = params['ds_group_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'd_s_group_users_add_request' in params:
            body_params = params['d_s_group_users_add_request']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='AddDSGroupAndUsersResponse',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def delete_ds_group(self, organization_id, account_id, ds_group_id, **kwargs):
        """
        Delete a DSGroup
        Required scopes: user_write
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.delete_ds_group(organization_id, account_id, ds_group_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :param str ds_group_id: The DSGroup ID GUID (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.delete_ds_group_with_http_info(organization_id, account_id, ds_group_id, **kwargs)
        else:
            (data) = self.delete_ds_group_with_http_info(organization_id, account_id, ds_group_id, **kwargs)
            return data

    def delete_ds_group_with_http_info(self, organization_id, account_id, ds_group_id, **kwargs):
        """
        Delete a DSGroup
        Required scopes: user_write
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.delete_ds_group_with_http_info(organization_id, account_id, ds_group_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :param str ds_group_id: The DSGroup ID GUID (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['organization_id', 'account_id', 'ds_group_id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_ds_group" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'organization_id' is set
        if ('organization_id' not in params) or (params['organization_id'] is None):
            raise ValueError("Missing the required parameter `organization_id` when calling `delete_ds_group`")
        # verify the required parameter 'account_id' is set
        if ('account_id' not in params) or (params['account_id'] is None):
            raise ValueError("Missing the required parameter `account_id` when calling `delete_ds_group`")
        # verify the required parameter 'ds_group_id' is set
        if ('ds_group_id' not in params) or (params['ds_group_id'] is None):
            raise ValueError("Missing the required parameter `ds_group_id` when calling `delete_ds_group`")


        collection_formats = {}

        resource_path = '/v2.1/organizations/{organizationId}/accounts/{accountId}/dsgroups/{dsGroupId}'.replace('{format}', 'json')
        path_params = {}
        if 'organization_id' in params:
            path_params['organizationId'] = params['organization_id']
        if 'account_id' in params:
            path_params['accountId'] = params['account_id']
        if 'ds_group_id' in params:
            path_params['dsGroupId'] = params['ds_group_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'DELETE',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type=None,
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def get_ds_group(self, organization_id, account_id, ds_group_id, **kwargs):
        """
        Get list of DSGroup
        Required scopes: user_read
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_ds_group(organization_id, account_id, ds_group_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :param str ds_group_id: The dsGroup ID GUID (required)
        :return: DSGroupResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.get_ds_group_with_http_info(organization_id, account_id, ds_group_id, **kwargs)
        else:
            (data) = self.get_ds_group_with_http_info(organization_id, account_id, ds_group_id, **kwargs)
            return data

    def get_ds_group_with_http_info(self, organization_id, account_id, ds_group_id, **kwargs):
        """
        Get list of DSGroup
        Required scopes: user_read
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_ds_group_with_http_info(organization_id, account_id, ds_group_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :param str ds_group_id: The dsGroup ID GUID (required)
        :return: DSGroupResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['organization_id', 'account_id', 'ds_group_id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_ds_group" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'organization_id' is set
        if ('organization_id' not in params) or (params['organization_id'] is None):
            raise ValueError("Missing the required parameter `organization_id` when calling `get_ds_group`")
        # verify the required parameter 'account_id' is set
        if ('account_id' not in params) or (params['account_id'] is None):
            raise ValueError("Missing the required parameter `account_id` when calling `get_ds_group`")
        # verify the required parameter 'ds_group_id' is set
        if ('ds_group_id' not in params) or (params['ds_group_id'] is None):
            raise ValueError("Missing the required parameter `ds_group_id` when calling `get_ds_group`")


        collection_formats = {}

        resource_path = '/v2.1/organizations/{organizationId}/accounts/{accountId}/dsgroups/{dsGroupId}'.replace('{format}', 'json')
        path_params = {}
        if 'organization_id' in params:
            path_params['organizationId'] = params['organization_id']
        if 'account_id' in params:
            path_params['accountId'] = params['account_id']
        if 'ds_group_id' in params:
            path_params['dsGroupId'] = params['ds_group_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='DSGroupResponse',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def get_ds_group_users(self, organization_id, account_id, ds_group_id, **kwargs):
        """
        Get list of users in a DSGroup
        Required scopes: user_read
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_ds_group_users(organization_id, account_id, ds_group_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :param str ds_group_id: The DSGroup ID GUID (required)
        :param int page: Start page of dsgroup users
        :param int page_size: Page size of dsgroup users
        :return: DSGroupAndUsersResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.get_ds_group_users_with_http_info(organization_id, account_id, ds_group_id, **kwargs)
        else:
            (data) = self.get_ds_group_users_with_http_info(organization_id, account_id, ds_group_id, **kwargs)
            return data

    def get_ds_group_users_with_http_info(self, organization_id, account_id, ds_group_id, **kwargs):
        """
        Get list of users in a DSGroup
        Required scopes: user_read
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_ds_group_users_with_http_info(organization_id, account_id, ds_group_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :param str ds_group_id: The DSGroup ID GUID (required)
        :param int page: Start page of dsgroup users
        :param int page_size: Page size of dsgroup users
        :return: DSGroupAndUsersResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['organization_id', 'account_id', 'ds_group_id', 'page', 'page_size']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_ds_group_users" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'organization_id' is set
        if ('organization_id' not in params) or (params['organization_id'] is None):
            raise ValueError("Missing the required parameter `organization_id` when calling `get_ds_group_users`")
        # verify the required parameter 'account_id' is set
        if ('account_id' not in params) or (params['account_id'] is None):
            raise ValueError("Missing the required parameter `account_id` when calling `get_ds_group_users`")
        # verify the required parameter 'ds_group_id' is set
        if ('ds_group_id' not in params) or (params['ds_group_id'] is None):
            raise ValueError("Missing the required parameter `ds_group_id` when calling `get_ds_group_users`")


        collection_formats = {}

        resource_path = '/v2.1/organizations/{organizationId}/accounts/{accountId}/dsgroups/{dsGroupId}/users'.replace('{format}', 'json')
        path_params = {}
        if 'organization_id' in params:
            path_params['organizationId'] = params['organization_id']
        if 'account_id' in params:
            path_params['accountId'] = params['account_id']
        if 'ds_group_id' in params:
            path_params['dsGroupId'] = params['ds_group_id']

        query_params = {}
        if 'page' in params:
            query_params['page'] = params['page']
        if 'page_size' in params:
            query_params['page_size'] = params['page_size']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='DSGroupAndUsersResponse',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def get_ds_groups(self, organization_id, account_id, **kwargs):
        """
        Get list of DSGroups
        Required scopes: user_read
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_ds_groups(organization_id, account_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :param int page: Start page of dsgroups
        :param int page_size: Page size of dsgroups
        :return: DSGroupListResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.get_ds_groups_with_http_info(organization_id, account_id, **kwargs)
        else:
            (data) = self.get_ds_groups_with_http_info(organization_id, account_id, **kwargs)
            return data

    def get_ds_groups_with_http_info(self, organization_id, account_id, **kwargs):
        """
        Get list of DSGroups
        Required scopes: user_read
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_ds_groups_with_http_info(organization_id, account_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :param int page: Start page of dsgroups
        :param int page_size: Page size of dsgroups
        :return: DSGroupListResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['organization_id', 'account_id', 'page', 'page_size']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_ds_groups" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'organization_id' is set
        if ('organization_id' not in params) or (params['organization_id'] is None):
            raise ValueError("Missing the required parameter `organization_id` when calling `get_ds_groups`")
        # verify the required parameter 'account_id' is set
        if ('account_id' not in params) or (params['account_id'] is None):
            raise ValueError("Missing the required parameter `account_id` when calling `get_ds_groups`")


        collection_formats = {}

        resource_path = '/v2.1/organizations/{organizationId}/accounts/{accountId}/dsgroups'.replace('{format}', 'json')
        path_params = {}
        if 'organization_id' in params:
            path_params['organizationId'] = params['organization_id']
        if 'account_id' in params:
            path_params['accountId'] = params['account_id']

        query_params = {}
        if 'page' in params:
            query_params['page'] = params['page']
        if 'page_size' in params:
            query_params['page_size'] = params['page_size']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='DSGroupListResponse',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def remove_ds_group_users(self, organization_id, account_id, ds_group_id, d_s_group_users_remove_request, **kwargs):
        """
        Remove users from a DSGroup
        Required scopes: user_write
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.remove_ds_group_users(organization_id, account_id, ds_group_id, d_s_group_users_remove_request, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :param str ds_group_id: The DSGroup ID GUID (required)
        :param DSGroupUsersRemoveRequest d_s_group_users_remove_request: Remove DSGroup users request object (required)
        :return: RemoveDSGroupUsersResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.remove_ds_group_users_with_http_info(organization_id, account_id, ds_group_id, d_s_group_users_remove_request, **kwargs)
        else:
            (data) = self.remove_ds_group_users_with_http_info(organization_id, account_id, ds_group_id, d_s_group_users_remove_request, **kwargs)
            return data

    def remove_ds_group_users_with_http_info(self, organization_id, account_id, ds_group_id, d_s_group_users_remove_request, **kwargs):
        """
        Remove users from a DSGroup
        Required scopes: user_write
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.remove_ds_group_users_with_http_info(organization_id, account_id, ds_group_id, d_s_group_users_remove_request, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :param str ds_group_id: The DSGroup ID GUID (required)
        :param DSGroupUsersRemoveRequest d_s_group_users_remove_request: Remove DSGroup users request object (required)
        :return: RemoveDSGroupUsersResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['organization_id', 'account_id', 'ds_group_id', 'd_s_group_users_remove_request']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method remove_ds_group_users" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'organization_id' is set
        if ('organization_id' not in params) or (params['organization_id'] is None):
            raise ValueError("Missing the required parameter `organization_id` when calling `remove_ds_group_users`")
        # verify the required parameter 'account_id' is set
        if ('account_id' not in params) or (params['account_id'] is None):
            raise ValueError("Missing the required parameter `account_id` when calling `remove_ds_group_users`")
        # verify the required parameter 'ds_group_id' is set
        if ('ds_group_id' not in params) or (params['ds_group_id'] is None):
            raise ValueError("Missing the required parameter `ds_group_id` when calling `remove_ds_group_users`")
        # verify the required parameter 'd_s_group_users_remove_request' is set
        if ('d_s_group_users_remove_request' not in params) or (params['d_s_group_users_remove_request'] is None):
            raise ValueError("Missing the required parameter `d_s_group_users_remove_request` when calling `remove_ds_group_users`")


        collection_formats = {}

        resource_path = '/v2.1/organizations/{organizationId}/accounts/{accountId}/dsgroups/{dsGroupId}/users'.replace('{format}', 'json')
        path_params = {}
        if 'organization_id' in params:
            path_params['organizationId'] = params['organization_id']
        if 'account_id' in params:
            path_params['accountId'] = params['account_id']
        if 'ds_group_id' in params:
            path_params['dsGroupId'] = params['ds_group_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'd_s_group_users_remove_request' in params:
            body_params = params['d_s_group_users_remove_request']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'DELETE',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='RemoveDSGroupUsersResponse',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)
