# coding: utf-8

"""
    DocuSign Admin API

    An API for an organization administrator to manage organizations, accounts and users  # noqa: E501

    OpenAPI spec version: v2.1
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..client.configuration import Configuration
from ..client.api_client import ApiClient


class ProductPermissionProfilesApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def add_user_product_permission_profiles(self, organization_id, account_id, user_id, product_permission_profiles_request, **kwargs):
        """
        Assign user to permission profiles for one or more products
        Required scopes: user_write
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.add_user_product_permission_profiles(organization_id, account_id, user_id, product_permission_profiles_request, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :param str user_id: The user ID GUID (required)
        :param ProductPermissionProfilesRequest product_permission_profiles_request: Request object (required)
        :return: UserProductPermissionProfilesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.add_user_product_permission_profiles_with_http_info(organization_id, account_id, user_id, product_permission_profiles_request, **kwargs)
        else:
            (data) = self.add_user_product_permission_profiles_with_http_info(organization_id, account_id, user_id, product_permission_profiles_request, **kwargs)
            return data

    def add_user_product_permission_profiles_with_http_info(self, organization_id, account_id, user_id, product_permission_profiles_request, **kwargs):
        """
        Assign user to permission profiles for one or more products
        Required scopes: user_write
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.add_user_product_permission_profiles_with_http_info(organization_id, account_id, user_id, product_permission_profiles_request, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :param str user_id: The user ID GUID (required)
        :param ProductPermissionProfilesRequest product_permission_profiles_request: Request object (required)
        :return: UserProductPermissionProfilesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['organization_id', 'account_id', 'user_id', 'product_permission_profiles_request']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_user_product_permission_profiles" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'organization_id' is set
        if ('organization_id' not in params) or (params['organization_id'] is None):
            raise ValueError("Missing the required parameter `organization_id` when calling `add_user_product_permission_profiles`")
        # verify the required parameter 'account_id' is set
        if ('account_id' not in params) or (params['account_id'] is None):
            raise ValueError("Missing the required parameter `account_id` when calling `add_user_product_permission_profiles`")
        # verify the required parameter 'user_id' is set
        if ('user_id' not in params) or (params['user_id'] is None):
            raise ValueError("Missing the required parameter `user_id` when calling `add_user_product_permission_profiles`")
        # verify the required parameter 'product_permission_profiles_request' is set
        if ('product_permission_profiles_request' not in params) or (params['product_permission_profiles_request'] is None):
            raise ValueError("Missing the required parameter `product_permission_profiles_request` when calling `add_user_product_permission_profiles`")


        collection_formats = {}

        resource_path = '/v2.1/organizations/{organizationId}/accounts/{accountId}/products/users/{userId}/permission_profiles'.replace('{format}', 'json')
        path_params = {}
        if 'organization_id' in params:
            path_params['organizationId'] = params['organization_id']
        if 'account_id' in params:
            path_params['accountId'] = params['account_id']
        if 'user_id' in params:
            path_params['userId'] = params['user_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'product_permission_profiles_request' in params:
            body_params = params['product_permission_profiles_request']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='UserProductPermissionProfilesResponse',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def add_user_product_permission_profiles_by_email(self, organization_id, account_id, user_product_permission_profiles_request, **kwargs):
        """
        Assign user to permission profiles for one or more products
        Required scopes: user_write
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.add_user_product_permission_profiles_by_email(organization_id, account_id, user_product_permission_profiles_request, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :param UserProductPermissionProfilesRequest user_product_permission_profiles_request: Request object (required)
        :return: UserProductPermissionProfilesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.add_user_product_permission_profiles_by_email_with_http_info(organization_id, account_id, user_product_permission_profiles_request, **kwargs)
        else:
            (data) = self.add_user_product_permission_profiles_by_email_with_http_info(organization_id, account_id, user_product_permission_profiles_request, **kwargs)
            return data

    def add_user_product_permission_profiles_by_email_with_http_info(self, organization_id, account_id, user_product_permission_profiles_request, **kwargs):
        """
        Assign user to permission profiles for one or more products
        Required scopes: user_write
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.add_user_product_permission_profiles_by_email_with_http_info(organization_id, account_id, user_product_permission_profiles_request, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :param UserProductPermissionProfilesRequest user_product_permission_profiles_request: Request object (required)
        :return: UserProductPermissionProfilesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['organization_id', 'account_id', 'user_product_permission_profiles_request']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_user_product_permission_profiles_by_email" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'organization_id' is set
        if ('organization_id' not in params) or (params['organization_id'] is None):
            raise ValueError("Missing the required parameter `organization_id` when calling `add_user_product_permission_profiles_by_email`")
        # verify the required parameter 'account_id' is set
        if ('account_id' not in params) or (params['account_id'] is None):
            raise ValueError("Missing the required parameter `account_id` when calling `add_user_product_permission_profiles_by_email`")
        # verify the required parameter 'user_product_permission_profiles_request' is set
        if ('user_product_permission_profiles_request' not in params) or (params['user_product_permission_profiles_request'] is None):
            raise ValueError("Missing the required parameter `user_product_permission_profiles_request` when calling `add_user_product_permission_profiles_by_email`")


        collection_formats = {}

        resource_path = '/v2.1/organizations/{organizationId}/accounts/{accountId}/products/permission_profiles/users'.replace('{format}', 'json')
        path_params = {}
        if 'organization_id' in params:
            path_params['organizationId'] = params['organization_id']
        if 'account_id' in params:
            path_params['accountId'] = params['account_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'user_product_permission_profiles_request' in params:
            body_params = params['user_product_permission_profiles_request']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='UserProductPermissionProfilesResponse',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def get_product_permission_profiles(self, organization_id, account_id, **kwargs):
        """
        Get products associated with the account and the available permission profiles
        Required scopes: user_read
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_product_permission_profiles(organization_id, account_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :return: ProductPermissionProfilesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.get_product_permission_profiles_with_http_info(organization_id, account_id, **kwargs)
        else:
            (data) = self.get_product_permission_profiles_with_http_info(organization_id, account_id, **kwargs)
            return data

    def get_product_permission_profiles_with_http_info(self, organization_id, account_id, **kwargs):
        """
        Get products associated with the account and the available permission profiles
        Required scopes: user_read
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_product_permission_profiles_with_http_info(organization_id, account_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :return: ProductPermissionProfilesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['organization_id', 'account_id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_product_permission_profiles" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'organization_id' is set
        if ('organization_id' not in params) or (params['organization_id'] is None):
            raise ValueError("Missing the required parameter `organization_id` when calling `get_product_permission_profiles`")
        # verify the required parameter 'account_id' is set
        if ('account_id' not in params) or (params['account_id'] is None):
            raise ValueError("Missing the required parameter `account_id` when calling `get_product_permission_profiles`")


        collection_formats = {}

        resource_path = '/v2.1/organizations/{organizationId}/accounts/{accountId}/products/permission_profiles'.replace('{format}', 'json')
        path_params = {}
        if 'organization_id' in params:
            path_params['organizationId'] = params['organization_id']
        if 'account_id' in params:
            path_params['accountId'] = params['account_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='ProductPermissionProfilesResponse',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def get_user_product_permission_profiles(self, organization_id, account_id, user_id, **kwargs):
        """
        Retrieve list of user's permission profiles for each account's product
        Required scopes: user_read
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_user_product_permission_profiles(organization_id, account_id, user_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :param str user_id: The user ID GUID (required)
        :return: ProductPermissionProfilesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.get_user_product_permission_profiles_with_http_info(organization_id, account_id, user_id, **kwargs)
        else:
            (data) = self.get_user_product_permission_profiles_with_http_info(organization_id, account_id, user_id, **kwargs)
            return data

    def get_user_product_permission_profiles_with_http_info(self, organization_id, account_id, user_id, **kwargs):
        """
        Retrieve list of user's permission profiles for each account's product
        Required scopes: user_read
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_user_product_permission_profiles_with_http_info(organization_id, account_id, user_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :param str user_id: The user ID GUID (required)
        :return: ProductPermissionProfilesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['organization_id', 'account_id', 'user_id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_user_product_permission_profiles" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'organization_id' is set
        if ('organization_id' not in params) or (params['organization_id'] is None):
            raise ValueError("Missing the required parameter `organization_id` when calling `get_user_product_permission_profiles`")
        # verify the required parameter 'account_id' is set
        if ('account_id' not in params) or (params['account_id'] is None):
            raise ValueError("Missing the required parameter `account_id` when calling `get_user_product_permission_profiles`")
        # verify the required parameter 'user_id' is set
        if ('user_id' not in params) or (params['user_id'] is None):
            raise ValueError("Missing the required parameter `user_id` when calling `get_user_product_permission_profiles`")


        collection_formats = {}

        resource_path = '/v2.1/organizations/{organizationId}/accounts/{accountId}/products/users/{userId}/permission_profiles'.replace('{format}', 'json')
        path_params = {}
        if 'organization_id' in params:
            path_params['organizationId'] = params['organization_id']
        if 'account_id' in params:
            path_params['accountId'] = params['account_id']
        if 'user_id' in params:
            path_params['userId'] = params['user_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='ProductPermissionProfilesResponse',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def get_user_product_permission_profiles_by_email(self, organization_id, account_id, **kwargs):
        """
        Remove user from permission profiles for one or more products
        Required scopes: user_write
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_user_product_permission_profiles_by_email(organization_id, account_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :param str email: Email address of the requested user
        :return: UserProductPermissionProfilesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.get_user_product_permission_profiles_by_email_with_http_info(organization_id, account_id, **kwargs)
        else:
            (data) = self.get_user_product_permission_profiles_by_email_with_http_info(organization_id, account_id, **kwargs)
            return data

    def get_user_product_permission_profiles_by_email_with_http_info(self, organization_id, account_id, **kwargs):
        """
        Remove user from permission profiles for one or more products
        Required scopes: user_write
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_user_product_permission_profiles_by_email_with_http_info(organization_id, account_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :param str email: Email address of the requested user
        :return: UserProductPermissionProfilesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['organization_id', 'account_id', 'email']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_user_product_permission_profiles_by_email" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'organization_id' is set
        if ('organization_id' not in params) or (params['organization_id'] is None):
            raise ValueError("Missing the required parameter `organization_id` when calling `get_user_product_permission_profiles_by_email`")
        # verify the required parameter 'account_id' is set
        if ('account_id' not in params) or (params['account_id'] is None):
            raise ValueError("Missing the required parameter `account_id` when calling `get_user_product_permission_profiles_by_email`")


        collection_formats = {}

        resource_path = '/v2.1/organizations/{organizationId}/accounts/{accountId}/products/permission_profiles/users'.replace('{format}', 'json')
        path_params = {}
        if 'organization_id' in params:
            path_params['organizationId'] = params['organization_id']
        if 'account_id' in params:
            path_params['accountId'] = params['account_id']

        query_params = {}
        if 'email' in params:
            query_params['email'] = params['email']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='UserProductPermissionProfilesResponse',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def remove_user_product_permission(self, organization_id, account_id, user_product_permission_profiles_request, **kwargs):
        """
        Remove user from permission profiles for one or more products
        Required scopes: user_write
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.remove_user_product_permission(organization_id, account_id, user_product_permission_profiles_request, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :param UserProductProfileDeleteRequest user_product_permission_profiles_request: Request object (required)
        :return: RemoveUserProductsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.remove_user_product_permission_with_http_info(organization_id, account_id, user_product_permission_profiles_request, **kwargs)
        else:
            (data) = self.remove_user_product_permission_with_http_info(organization_id, account_id, user_product_permission_profiles_request, **kwargs)
            return data

    def remove_user_product_permission_with_http_info(self, organization_id, account_id, user_product_permission_profiles_request, **kwargs):
        """
        Remove user from permission profiles for one or more products
        Required scopes: user_write
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.remove_user_product_permission_with_http_info(organization_id, account_id, user_product_permission_profiles_request, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str organization_id: The organization ID GUID (required)
        :param str account_id: The account ID GUID (required)
        :param UserProductProfileDeleteRequest user_product_permission_profiles_request: Request object (required)
        :return: RemoveUserProductsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['organization_id', 'account_id', 'user_product_permission_profiles_request']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method remove_user_product_permission" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'organization_id' is set
        if ('organization_id' not in params) or (params['organization_id'] is None):
            raise ValueError("Missing the required parameter `organization_id` when calling `remove_user_product_permission`")
        # verify the required parameter 'account_id' is set
        if ('account_id' not in params) or (params['account_id'] is None):
            raise ValueError("Missing the required parameter `account_id` when calling `remove_user_product_permission`")
        # verify the required parameter 'user_product_permission_profiles_request' is set
        if ('user_product_permission_profiles_request' not in params) or (params['user_product_permission_profiles_request'] is None):
            raise ValueError("Missing the required parameter `user_product_permission_profiles_request` when calling `remove_user_product_permission`")


        collection_formats = {}

        resource_path = '/v2.1/organizations/{organizationId}/accounts/{accountId}/products/users'.replace('{format}', 'json')
        path_params = {}
        if 'organization_id' in params:
            path_params['organizationId'] = params['organization_id']
        if 'account_id' in params:
            path_params['accountId'] = params['account_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'user_product_permission_profiles_request' in params:
            body_params = params['user_product_permission_profiles_request']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'DELETE',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='RemoveUserProductsResponse',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)
